#!/usr/bin/python
# -*- coding: utf-8 -*-

"""Usage: shadow_crack.py shadow_crack.conf

A simple brute force cracker for /etc/shadow,
designed to recover forgotten passwords.

To properly use this program,
edit and configure to taste one of the files
shadow_crack.conf... .
"""

# License: GNU Public License v 2.1
# Copyright:  mennucc1@debian.org 2013
# Version: 1.0
# Homepage: http://mennucc1.debian.net/shadow_crack/

# This script was kept as simple as possible (but not more) to show
# that it really does what it says (and is not secretly emailing your
# passwords to an evil empire, or the NSA)

# It is loosely based on the code in
# http://www.devconsole.info/?p=211

# The generative model is somewhat similar to what is described in
# http://www.iusmentis.com/security/passphrasefaq/strength/

# This is a very simple program, if you need something that really
# cracks generic passwords, start from
# http://arstechnica.com/security/2013/03/how-i-became-a-password-cracker

import os, sys, string, copy, crypt, time
from datetime import datetime,timedelta
from math import pow, log

try:
    import sqlite3
except ImportError:
    print '[!] Please install the Python SQLITE3 module'
    sqlite3=None

try:
    # get terminal size, if any
    import termios, fcntl, struct
    # from http://stackoverflow.com/questions/17637640/what-is-happening-in-this-python-code-to-get-the-terminal-window-size
    # see also http://stackoverflow.com/questions/566746/how-to-get-console-window-width-in-python
    s = struct.pack("HHHH", 0, 0, 0, 0)
    fd_stdout = sys.stdout.fileno()
    x = fcntl.ioctl(fd_stdout, termios.TIOCGWINSZ, s)
    (terminalrows , terminalcolumns) = struct.unpack("HHHH", x)[:2]
    # use it to design a function to pretty print program progress
    def print_progress(s):
        "pretty print a program progress string"
        if len(s) >  terminalcolumns-4:
            sys.stderr.write(s[:terminalcolumns-4]+'...\r')
        else:
            sys.stderr.write(s.ljust(terminalcolumns-1)+'\r')
except Exception, e:
    print '[!] No progress reporting on this terminal: ',str(e)
    (terminalrows , terminalcolumns) =  (None, None)
    def print_progress(s):
        pass

######## classes and functions

# see shadow_crack_extra.py for a test class

class test_shadow(object):
    "class to store encrypted passwords from  /etc/shadow and then test them"
    def __init__(self, the_shadow, the_users=True):
        self.users={}
        # parse shadow file
        for line in open(the_shadow,'r'):
            line = line.replace("\n","").split(":")
            if  not line[1] in [ 'x', '*','!' ] \
                and ( the_users == True or line[0] in the_users ):
                user = line[0]
                cryptPass = line[1]
                if '$' not in  cryptPass:
                    print '[+] not encoded using md5 or sha',user,cryptPass
                else:
                    ctype = cryptPass.split("$")[1]
                    salt = cryptPass.split("$")[2]
                    insalt = "$" + ctype + "$" + salt + "$"
                    self.users[user]=insalt,cryptPass
        print '[+] Cracking shadow users ',string.join(self.users.keys())
    def exclude_known(self, l):
        "exclude already found user and passwords"
        for user,word in l:
            if user in self.users:
                del self.users[user]
    def test(self, word):
        " tries the words as possible password, returns a list of found results"
        s=[]
        for user in copy.copy(self.users.keys()):
            insalt, cryptPass = self.users[user]
            cryptWord = crypt.crypt(word,insalt)
            if cryptWord == cryptPass:
                del self.users[user]
                s.append((user,word))
        return s
    def __len__(self):
        "the instance is true as long as there is something to break"
        return len(self.users.keys())
    def status(self):
        if not self.users:
            return ' All  passwords found'
        else:
            return ' The passwords for these users were not found so far: '+str(self.users.keys())


class mydb(object):
    """ persistent sqlite3 database to store tried words and cracked passwords """
    conn = None
    def __init__(self,f):
        self.conn  = sqlite3.connect(f)
        # Create table
        c=self.conn.cursor()
        t=c.execute("SELECT name FROM sqlite_master WHERE type='table';").fetchone()
        if not t or 'tried' not in t[0]:
            c.execute('create table tried (word text);')
            c.execute('create index triedindex on tried (word);')
            c.execute('create table user_password (user text, password text);')
    def add_word(self,z):
        c = self.conn.cursor()
        # Insert a row of data
        c.execute("insert into tried  values (?) ;", (z,))
        # Save (commit) the changes
        self.conn.commit()
    def add_words(self,l):
        c = self.conn.cursor()
        for z in l:
            c.execute("insert into tried  values (?) ;", (z,))
        self.conn.commit()
    def store_cracked(self, u, p):
        c = self.conn.cursor()
        c.execute("insert into user_password  values (?,?) ;", (u,p))
        self.conn.commit()
    def retrieve_cracked(self):
        c = self.conn.cursor()
        c.execute("select * from user_password ;")
        return c.fetchall()
    def __contains__(self,z):
        c = self.conn.cursor()
        c.execute('select * from tried where word=? ;', (z,))
        a= c.fetchone()
        return a

def generate_lists(words, symbols, depth):
    if depth <= 0:
        yield []
    else:
        # generates lists of words and symbols
        gen=generate_lists(words, symbols, depth-1)
        for lis in gen:
            for j in words + symbols:
                yield lis+[j]
        # insert symbols in words
        if depth > 1 and use_insertion:
            gen=generate_lists(words, symbols, depth-1)
            for lis in gen:
                las=lis.pop()
                if len(las) >= 3:
                    for p in range(1,len(las)):
                        for j in  symbols:
                            wo = las[:p]+j+las[p:]
                            yield lis+[wo]
        # delete letters from  words
        if depth > 1 and use_deletion:
            gen=generate_lists(words, symbols, depth-1)
            for lis in gen:
                las=lis.pop()
                if len(las) >= 3:
                    for p in range(0,len(las)):
                        wo = las[:p]+las[p+1:]
                        yield lis+[wo]
        # capitalize in words
        if depth > 1 and use_capitalization:
            gen=generate_lists(words, symbols, depth-1)
            for lis in gen:
                las=lis.pop()
                for p in range(len(las)):
                    l=las[p]
                    u=string.capitalize(l)
                    if l != u:
                        wo = las[:p]+u+las[p+1:]
                        yield lis+[wo]
        # generates pieces of words
        if depth >= 2 and  use_pieces:
            gen=generate_lists(words, symbols, depth-2)
            for lis in gen:
                for word in words:
                    if len(word) >= 4:
                        for j in range(len(word)):
                            for i in range(j):
                                yield lis+[word[i:j+1]]


def generate_words(words, symbols, max_depth):
    #just in case
    yield ''
    for d in range(1,max_depth+1):
        print_progress('')
        print '[+] Generating passwords of complexity ',d
        for l in generate_lists(words, symbols, d):
            #print l
            yield string.join(l,'')


def crack_passwords(tester, symbols, words, max_complexity, db):
    testedset=set()
    count = 0
    duplicates = 0
    gener = generate_words(words, symbols,  max_complexity)
    today = datetime.today()
    now = time.time()
    
    last_progress = now
    try:
        for word in gener:
            if ( count % 10 ) == 0 and     ( last_progress + 1. < time.time()) :
                last_progress = time.time()
                print_progress('> %d (%d/sec, dup %3.1f%%), word %r' % \
                               (count, count / (last_progress - now),
                                100. * float(duplicates)/float(count), word))
            if db and ( count % 200000 ) == 0:
                print_progress('Dumping database...')
                db.add_words(testedset)
                testedset=set()
                print_progress('Dumping database.....done.')

            if word in testedset or (db and word in db):
                duplicates += 1
            else:
                testedset.add(word)
                for user,password in tester.test(word):
                    if db: db.store_cracked(user,password)
                    print_progress('')
                    print '[+] Found '+repr(user)+' => '+repr(password)
                    print "[+]  at time "+str(datetime.today() - today)+", tried "+str(count)
                #if nothing else to test, return
                if not tester:
                    if db:  db.add_words(testedset)
                    break #return count, duplicates
            count += 1
        print_progress('')
        print '[+] '+ the_tester.status()
        if db:  db.add_words(testedset)
        return count, duplicates
    except KeyboardInterrupt:
        # on ctrl-c dump the database
        try:
            print_progress('')
            if db:
                print '[+] emergency dumping of database '
                db.add_words(testedset)
        except:
            pass
        raise
    finally:
        print_progress('')
        print "[+] Total time: "+str(datetime.today() - today)
        print '[+] Total tried %d (%d/sec), %d unique and new' % \
            (count, count / (time.time() - now), count-duplicates)
        print '[+] '+ the_tester.status()

#### main code

def main(the_conf):
    # read configuration variables
    execfile(the_conf, locals(), globals())

    global the_words
    global the_symbols

    if type(the_symbols) in (str,unicode,tuple):
        the_symbols = list(the_symbols)
    assert type(the_symbols) == list
    if not all([(len(a)==1) for a in the_symbols]):
        print '[!] Warning, some symbols are not of length 1'

    ### prepare list of words
    if the_file_of_words:
        #load from files, if given
        the_words += map(str.rstrip, open(the_file_of_words,'r').readlines())

    #remove empty strings from words
    the_words = [a for a in the_words if a]

    if  not the_words  and not the_symbols  :
        print " Please customize the file, provide symbols and/or words: ", the_conf
        sys.exit(0)

    if use_reverses:
        the_words +=   [a[::-1] for a in the_words]

    #remove duplicates
    the_words=list(set(the_words))
    #sort for increasing length
    the_words.sort(cmp=lambda x,y : cmp(len(x),len(y)))

    print '[+] Using %d words and %d symbols.' % (len(the_words),len(the_symbols))

    if sqlite3 == None or the_sqlite3_file == None:
        db=None
    else:
        print '[+] Dictionary of tried words in ', the_sqlite3_file
        db=mydb(the_sqlite3_file)
        known=db.retrieve_cracked()
        if known:
            print '[+] these user,pass were already found',known
            the_tester.exclude_known(known)
        print '[+] '+ the_tester.status()
    if not the_tester:
        print '[+] No work to be done'
        return

    crack_passwords(the_tester, the_symbols, the_words , the_max_complexity, db)

if __name__=="__main__":
    try:
        if len(sys.argv) > 1:
            main(sys.argv[1])
        else:
            print __doc__
    except KeyboardInterrupt:
        print '[-] Bye Bye'
    sys.exit(0)
